on setMyVolume theChannel, theMacVol, thePCVol
  if machineType() < 255 then
    set the volume of sound theChannel to theMacVol
  else
    set the volume of sound theChannel to thePCVol
  end if
end

on FadeMyVolume theChannel, theTime, theGrain, theLevelMac, theLevelPC
  if machineType() < 255 then
    set theLevel to theLevelMac
  else
    set theLevel to theLevelPC
  end if
  puppetTempo(theTime)
  if theChannel = 3 then
    repeat while (the volume of sound 1 > theLevel) or (the volume of sound 2 > theLevel)
      if the volume of sound 1 > theLevel then
        set the volume of sound 1 to the volume of sound 1 - theGrain
      end if
      if the volume of sound 2 > theLevel then
        set the volume of sound 2 to the volume of sound 2 - theGrain
      end if
      pWait(theTime)
    end repeat
    if theLevel = 0 then
      sound stop 1
      sound stop 2
    end if
  else
    repeat while the volume of sound theChannel > theLevel
      set the volume of sound theChannel to the volume of sound theChannel - theGrain
      pWait(theTime)
    end repeat
    if theLevel = 0 then
      sound stop theChannel
    end if
  end if
end

on doFancyCursor
  repeat with nn = 1 to 5
    cursor("fancyC" & nn)
    pWait(30)
  end repeat
end

on pWait theTicks
  set tmpTicks to the ticks
  repeat while the ticks < (tmpTicks + theTicks)
  end repeat
end

on MouseLoc
  return point(the mouseH, the mouseV)
end
